#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <winnt.h>

int dec1( FILE *fp, int *buf);

typedef struct {
	int RiffHeader;
	unsigned int FileSize;
	int WavHeader;
} WavFileHead;
WavFileHead stFileHead = { 'FFIR', 0, 'EVAW'};

typedef struct {
  int  chunkID;
  long           chunkSize; 
  short          wFormatTag;
  unsigned short wChannels;
  unsigned long  dwSamplesPerSec;
  unsigned long  dwAvgBytesPerSec;
  unsigned short wBlockAlign;
  unsigned short wBitsPerSample;
} FormatChunk;
FormatChunk stWavFormat = { ' tmf', 0x10, (short)1, 2, 48000, 48000*2*2, 2*2, 16};

typedef struct {
  int  chunkID;
  long           chunkSize; 
  unsigned char  waveformData[];
} DataChunk;
DataChunk stWavData = { 'atad', 0};

void main( int argc, char* argv[])
{
	FILE *fp, *fp2;
	int bytes;
	char *buf;
	extern errno;
	int pcode;
	char filename[1024];
	int datasize;

	if( argc < 2){
		printf("PV3WAV  PV3.DAT\n");
		exit( 1);
	}

	if ((fp = fopen(argv[ 1], "rb")) == NULL){
		printf("fopen error %d\n", errno);
		exit(1);
	}
	fprintf(stderr, "Input File %s :", argv[1]);

	fseek( fp, 0, 2);
	bytes = ftell( fp);
	fprintf(stderr, "%d \n", bytes);
	fseek( fp, 0, 0);
	buf = VirtualAlloc( NULL, bytes, MEM_COMMIT, PAGE_EXECUTE_READWRITE);
	if( buf == NULL){
		printf("malloc error %d\n",GetLastError());
		exit(2);
	}
	fread( buf, bytes, 1, fp);
	fclose( fp);

	for( pcode=0x400; pcode<bytes; pcode+=0x800){
		if( buf[ pcode] == 0)
			continue;

		sprintf( filename, "%s%02d.wav", argv[1], (pcode-0x400)/0x800+1);
		if ((fp2 = fopen( filename, "wb")) == NULL){
			printf("fopen error %s %d\n", filename, errno);
			exit(1);
		}

		fwrite( &stFileHead, sizeof( stFileHead), 1, fp2);
		fwrite( &stWavFormat, sizeof( stWavFormat), 1, fp2);
		fwrite( &stWavData, 0x08, 1, fp2);

		datasize = dec1( fp2, (int *)&buf[ pcode]);
		fseek( fp2, 0x28, 0);
		fwrite( &datasize, sizeof( int), 1, fp2);
		datasize+=0x24;
		fseek( fp2, 4, 0);
		fwrite( &datasize, sizeof( int), 1, fp2);

		fclose( fp2);
	}

	VirtualFree( buf, bytes, MEM_DECOMMIT);
	exit(0);
}

int dec1( FILE *fp, int *buf)
{
	int count, loops, i;
	int marks, onoff;
	unsigned char mark[4] = { 0x00, 0x60, 0x00, 0x60};
	unsigned char space[4] = { 0x00, 0x00, 0x00, 0x00};

	count = 0;
	for( i=0; i<0x80; i++){
		fwrite( space, 4, 1, fp);
	}
	count += 0x80*2*2;

	onoff = 1;
	for( loops=1; loops<0x800/4; loops++){
		marks = buf[ loops];
		if( marks == 0)
			break;
		if( marks > 0x100000)
			break;
		if( onoff){
			for( i=0; i<marks/0x15c; i++){
				fwrite( mark, 4, 1, fp);
			}
			count += marks/0x15c*2*2;
			onoff = 0;
		}else{
			for( i=0; i<marks/0x15c; i++){
				fwrite( space, 4, 1, fp);
			}
			count += marks/0x15c*2*2;
			onoff = 1;
		}
		if( count > 60*1024)
			break;
	}

	for( i=0; i<0x80; i++){
		fwrite( space, 4, 1, fp);
	}
	count += 0x80*2*2;

	return count;
}

